import { BlankNode, DataFactory, DatasetCore, Literal, NamedNode, Quad, Term, Variable } from '@rdfjs/types';
import type { NamespaceBuilder } from '@rdfjs/namespace';
import type { Environment } from '@rdfjs/environment/Environment.js';
import type { TermMapFactory } from '@rdfjs/term-map/Factory.js';
import { Value } from './value.js';
import { PartialString, SerializationStrategy, TemplateResult } from './TemplateResult.js';
export interface SparqlOptions {
    env: Environment<DataFactory | TermMapFactory>;
    base?: string;
    prologue: boolean;
    prefixes?: Record<string, string | NamespaceBuilder>;
    noPrefixedNames?: boolean;
}
export type SparqlTemplateResult = TemplateResult<SparqlOptions>;
export type SparqlValue<T extends Term = Term> = Value<SparqlTemplateResult, T>;
export declare class SparqlStrategy extends SerializationStrategy<SparqlOptions> {
    evaluateLiteral(term: Literal, options: SparqlOptions): PartialString;
    evaluateNamedNode(term: NamedNode, options: SparqlOptions): PartialString;
    evaluateBlankNode(term: BlankNode): PartialString;
    evaluateVariable(term: Variable): PartialString;
    getFinalString(result: string, prefixes: Iterable<string>, options: SparqlOptions): string;
    evaluateDataset(dataset: DatasetCore, options: SparqlOptions): PartialString;
    evaluateQuad(quad: Quad, options: SparqlOptions): PartialString;
    private __evaluateTripleArray;
}
export declare const sparql: (strings: TemplateStringsArray, ...values: SparqlValue[]) => SparqlTemplateResult;
//# sourceMappingURL=sparql.d.ts.map